#!/usr/bin/perl

# list 6

use strict;
use warnings;

sub make_counter {
    my ($counter) = @_;     # この変数が封じ込められる

    return {
        inc => sub {  return ++$counter },
        dec => sub {  return --$counter }
    };
}

my $foo = make_counter(0);   # 初期値 0のカウンタ
my $bar = make_counter(100); # 初期値 100のカウンタ

print $foo->{inc}(), "\n";   # 1
print $bar->{inc}(), "\n";   # 101
print $bar->{inc}(), "\n";   # 102
print $foo->{inc}(), "\n";   # 2
print $bar->{inc}(), "\n";   # 103
print $foo->{inc}(), "\n";   # 3
print $foo->{dec}(), "\n";   # 2
print $bar->{dec}(), "\n";   # 102
